Package org.apache.sysds.runtime.lineage

# Class LineageItem

java.lang.Object
org.apache.sysds.runtime.lineage.LineageItem

public class LineageItem extends Object

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static enum`
`LineageItem.LineageItemType`

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`dedupItemOpcode`

## Constructor Summary

Constructors
Constructor
Description
`LineageItem()`
`LineageItem(long id, String data)`
`LineageItem(long id, String data, String opcode)`
`LineageItem(long id, String data, String opcode, LineageItem[] inputs, int specialValueBits)`
`LineageItem(long id, LineageItem li)`
`LineageItem(String data)`
`LineageItem(String data, String opcode)`
`LineageItem(String data, String opcode, LineageItem[] inputs)`
`LineageItem(String opcode, LineageItem[] inputs)`
`LineageItem(String opcode, LineageItem dedupPatch, int dpatchHash, LineageItem[] inputs)`
`LineageItem(String opcode, LineageItem dedupPatch, LineageItem[] inputs)`
`LineageItem(LineageItem li)`

## Method Summary

Modifier and Type
Method
Description
`LineageItem`
`deepCopy()`
`boolean`
`equals(Object o)`
`String`
`getData()`
`LineageItem`
`getDedupPatch()`
`long`
`getHeight()`
`long`
`getId()`
`LineageItem[]`
`getInputs()`
`String`
`getOpcode()`
`boolean`
`getSpecialValueBit(int pos)`
`int`
`getSpecialValueBits()`
`LineageItem.LineageItemType`
`getType()`
`int`
`hashCode()`
`boolean`
`isDedup()`
`boolean`
`isInstruction()`
`boolean`
`isLeaf()`
`boolean`
`isPlaceholder()`
`boolean`
`isVisited()`
`void`
`resetHash()`
`static void`
`resetIDSequence()`
`void`
`resetInputs()`
`void`
`resetVisitStatus()`
Deprecated.
`static void`
`resetVisitStatus(LineageItem[] lis)`
Deprecated.
`void`
`resetVisitStatusNR()`
Non-recursive equivalent of `resetVisitStatus()` for robustness with regard to stack overflow errors.
`static void`
`resetVisitStatusNR(LineageItem[] lis)`
Non-recursive equivalent of `resetVisitStatus(LineageItem[])` for robustness with regard to stack overflow errors.
`void`
`setHeight(long height)`
`void`
`setInput(int i, LineageItem item)`
`void`
`setSpecialValueBit(int pos, boolean flag)`
`void`
`setSpecialValueBits(int value)`
`void`
`setVisited()`
`void`
`setVisited(boolean flag)`
`String`
`toString()`

### Methods inherited from class java.lang.Object

`getClass, notify, notifyAll, wait, wait, wait`

## Field Details

### dedupItemOpcode

public static final String dedupItemOpcode

See Also:
  - Constant Field Values

## Constructor Details

### LineageItem

public LineageItem()

### LineageItem

public LineageItem(String data)

### LineageItem

public LineageItem(long id, String data)

### LineageItem

public LineageItem(String data, String opcode)

### LineageItem

public LineageItem(String opcode, LineageItem[] inputs)

### LineageItem

public LineageItem(String data, String opcode, LineageItem[] inputs)

### LineageItem

public LineageItem(String opcode, LineageItem dedupPatch, LineageItem[] inputs)

### LineageItem

public LineageItem(String opcode, LineageItem dedupPatch, int dpatchHash, LineageItem[] inputs)

### LineageItem

public LineageItem(LineageItem li)

### LineageItem

public LineageItem(long id, LineageItem li)

### LineageItem

public LineageItem(long id, String data, String opcode)

### LineageItem

public LineageItem(long id, String data, String opcode, LineageItem[] inputs, int specialValueBits)

## Method Details

### getInputs

public LineageItem[] getInputs()

### resetInputs

public void resetInputs()

### setInput

public void setInput(int i, LineageItem item)

### getData

public String getData()

### getHeight

public long getHeight()

### setHeight

public void setHeight(long height)

### resetHash

public void resetHash()

### isVisited

public boolean isVisited()

### setVisited

public void setVisited()

### setVisited

public void setVisited(boolean flag)

### setSpecialValueBit

public void setSpecialValueBit(int pos, boolean flag)

### setSpecialValueBits

public void setSpecialValueBits(int value)

### getId

public long getId()

### getOpcode

public String getOpcode()

### getSpecialValueBit

public boolean getSpecialValueBit(int pos)

### getSpecialValueBits

public int getSpecialValueBits()

### isPlaceholder

public boolean isPlaceholder()

### getDedupPatch

public LineageItem getDedupPatch()

### getType

public LineageItem.LineageItemType getType()

### toString

public String toString()

Overrides:
  `toString` in class `Object`

### equals

public boolean equals(Object o)

Overrides:
  `equals` in class `Object`

### hashCode

public int hashCode()

Overrides:
  `hashCode` in class `Object`

### deepCopy

public LineageItem deepCopy()

### isLeaf

public boolean isLeaf()

### isInstruction

public boolean isInstruction()

### isDedup

public boolean isDedup()

### resetVisitStatusNR

public void resetVisitStatusNR()
Non-recursive equivalent of `resetVisitStatus()` for robustness with regard to stack overflow errors.

### resetVisitStatusNR

public static void resetVisitStatusNR(LineageItem[] lis)
Non-recursive equivalent of `resetVisitStatus(LineageItem[])` for robustness with regard to stack overflow errors.

Parameters:
  `lis` - root lineage items

### resetVisitStatus

@Deprecated public void resetVisitStatus()
Deprecated.

### resetVisitStatus

@Deprecated public static void resetVisitStatus(LineageItem[] lis)
Deprecated.

### resetIDSequence

public static void resetIDSequence()